﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Entitats;
using Negoci;

namespace Negoci
{
    public class ArticuloBL
    {

        private SaisOnlineEntities context;

        public ArticuloBL()
        {
            context = new SaisOnlineEntities();
        }


        public List<Articulo> GetArticulos()
        {
            List<Articulo> lista = new List<Articulo>();
            try
            {
                lista = context.Articulo.ToList();
            }
            catch (Exception)
            {
                return lista;
            }

            return lista;
        }

        public Articulo GetArticuloByCodigo(string codigo)
        {
            Articulo art = new Articulo();
            try
            {
                var articulo = from a in context.Articulo where a.codigo == codigo select a;

                art = articulo.FirstOrDefault<Articulo>();
            }
            catch (Exception)
            {
                return art;
            }

            return art;
        }

        public List<Articulo> GetArticulosByCategoria(String codi_categoria)
        {
            List<Articulo> lista = new List<Articulo>();
            try
            {
                if (codi_categoria != "0")
                {
                    var articulo = from a in context.Articulo where a.categoria == codi_categoria select a;
                    lista = articulo.ToList();
                }
                else
                {
                    var articulo = from a in context.Articulo select a;
                    lista = articulo.ToList();
                }
            }
            catch (Exception)
            {
                return lista;
            }

            return lista;
        }

        public List<viewArticulo> GetViewArticulosByCategoria(String codi_categoria)
        {
            List<viewArticulo> lista = new List<viewArticulo>();
            try
            {
                if (codi_categoria != "0")
                {
                    var articulo = from a in context.viewArticulo where a.categoria == codi_categoria select a;
                    lista = articulo.ToList();
                }
                else
                {
                    var articulo = from a in context.viewArticulo select a;
                    lista = articulo.ToList();
                }
            }
            catch (Exception)
            {
                return lista;
            }
            return lista;
        }

        public viewArticulo GetViewArticulosByCodigo(String codigo)
        {
            viewArticulo art = new viewArticulo();
            try
            {
                var articulo = from a in context.viewArticulo where a.codigo == codigo select a;
                art = articulo.FirstOrDefault<viewArticulo>();
            }
            catch (Exception)
            {
                return art;
            }
            return art;
        }

        public int InsertArticulo(string codigo, string descripcion, string descripcion_larga, string categoria, decimal precio_iva, string tipo_iva, int stock, string ruta_foto)
        {
            Articulo art = new Articulo();
            try
            {
                art.codigo = codigo;
                art.descripcion = descripcion;
                art.descripcion_larga = descripcion_larga;
                art.categoria = categoria;
                art.precio_iva = precio_iva;
                art.tipo_iva = tipo_iva;
                art.stock = stock;
                art.ruta_foto = ruta_foto;

                context.Articulo.AddObject(art);

                return context.SaveChanges();
            }
            catch (Exception)
            {
                return 0;
            }
        }

        public int UpdateArticulo(string codigo, string descripcion, string descripcion_larga, string categoria, decimal precio_iva, string tipo_iva, int stock, string ruta_foto)
        {
            Articulo art = new Articulo();
            try
            {
                var obj = from a in context.Articulo where a.codigo == codigo select a;

                art = obj.FirstOrDefault<Articulo>();

                art.descripcion = descripcion;
                art.descripcion_larga = descripcion_larga;
                art.categoria = categoria;
                art.precio_iva = precio_iva;
                art.tipo_iva = tipo_iva;
                art.stock = stock;
                art.ruta_foto = ruta_foto;

                return context.SaveChanges();
            }
            catch (Exception)
            {
                return 0;
            }
        }

        public int UpdateCantidadArticulo(string codigo, int stock)
        {
            Articulo art = new Articulo();
            try
            {
                var obj = from a in context.Articulo where a.codigo == codigo select a;

                art = obj.FirstOrDefault<Articulo>();

                art.stock = stock;

                return context.SaveChanges();
            }
            catch (Exception)
            {
                return 0;
            }
        }


        public int DeleteArticulo(string codigo)
        {
            Articulo art = new Articulo();
            try
            {
                var obj = from a in context.Articulo where a.codigo == codigo select a;

                art = obj.FirstOrDefault<Articulo>();

                context.Articulo.DeleteObject(art);

                return context.SaveChanges();
            }
            catch (Exception)
            {
                return 0;
            }
        }

    }
}
