﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Entitats;

namespace Negoci
{
    public class CategoriaBL
    {
        //Entitats.SaisOnlineEntities m_Context = new SaisOnlineEntities();

        //public Entitats.SaisOnlineEntities Context
        //{

        //    get { return m_Context; }
        //    set { m_Context = value; }
        //}

        private SaisOnlineEntities context;

        public CategoriaBL()
        {
            context = new SaisOnlineEntities();
        }

        public List<Categoria> GetCategoriasNoEnvio()
        {
            List<Categoria> lista = new List<Categoria>();
            try
            {
                var categoria =
                    from c in context.Categoria
                    where c.codigo != "E"
                    select c;

                lista = categoria.ToList<Categoria>();
            }
            catch (Exception)
            {
                return lista;
            }
            return lista;
        }

        public List<Categoria> GetCategorias()
        {
            List<Categoria> lista = new List<Categoria>();
            try
            {
                var categoria =
                    from c in context.Categoria
                    select c;

                lista = categoria.ToList<Categoria>();
            }
            catch (Exception)
            {
                return lista;
            }
            return lista;
        }

        public Categoria GetCategoriaoByCodigo(string codigo)
        {
            Categoria cat = new Categoria();
            try
            {
                var categoria = from c in context.Categoria where c.codigo == codigo select c;

                cat = categoria.FirstOrDefault<Categoria>();
            }
            catch (Exception)
            {
                return cat;
            }
            return cat;
        }

        public int InsertCategoria(string codigo, string descripcion)
        {
            Categoria cat = new Categoria();
            try
            {
                cat.codigo = codigo;
                cat.descripcion = descripcion;

                context.Categoria.AddObject(cat);
                return context.SaveChanges();
            }
            catch (Exception)
            {
                return 0;
            }
        }

        public int UpdateCategoria(string codigo, string descripcion)
        {
            Categoria cat = new Categoria();
            try
            {
                var obj = from c in context.Categoria where c.codigo == codigo select c;

                cat = obj.FirstOrDefault<Categoria>();

                cat.descripcion = descripcion;

                return context.SaveChanges();
            }
            catch (Exception)
            {
                return 0;
            }
        }

        public int DeleteCategoria(string codigo)
        {
            Categoria cat = new Categoria();
            try
            {
                var obj = from c in context.Categoria where c.codigo == codigo select c;

                cat = obj.FirstOrDefault<Categoria>();

                context.Categoria.DeleteObject(cat);

                return context.SaveChanges();
            }
            catch (Exception)
            {
                return 0;
            }
        }


    }
}
