﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Entitats;

namespace Negoci
{
    public class MovimientoBL
    {
        private SaisOnlineEntities context;

        public MovimientoBL()
        {
            context = new SaisOnlineEntities();
        }

        public MovimientoBL(SaisOnlineEntities context)
        {
            this.context = context;
        }

        public List<viewMovimiento> GetViewMovimiento(string articulo)
        {
            List<viewMovimiento> mov = new List<viewMovimiento>();
            try
            {
                if (articulo != "")
                {
                    var movim = from m in context.viewMovimiento where m.articulo == articulo select m;
                    mov = movim.ToList();
                }
                else
                {
                    var movim = from m in context.viewMovimiento select m;
                    mov = movim.ToList();
                }
            }
            catch (Exception)
            {
                return mov;
            }

            return mov;
        }

        public Movimiento GetMovimientoById(int id)
        {
            Movimiento mov = new Movimiento();
            try
            {
                var movim = from m in context.Movimiento where m.id_mov == id select m;

                mov = movim.FirstOrDefault<Movimiento>();
            }
            catch (Exception)
            {
                return mov;
            }

            return mov;
        }

        public List<TipoMovimiento> GetTipoMovim()
        {
            List<TipoMovimiento> tp_mov = new List<TipoMovimiento>();
            try
            {
                var tipo = from t in context.TipoMovimiento select t;

                tp_mov = tipo.ToList();
            }
            catch (Exception)
            {
                return tp_mov;
            }

            return tp_mov;
        }

        public int InsertMovimiento(string tipo_mov, string articulo, int cantidad)
        {
            Movimiento mov = new Movimiento();
            Articulo art = new Articulo();
            ArticuloBL articuloBL = new ArticuloBL();
            string tipo = "";
            int cant_nueva=0;

            try
            {
                var lista = from a in context.Articulo where a.codigo == articulo select a;
                art = lista.FirstOrDefault<Articulo>();

                var lista2 = from t in context.TipoMovimiento where t.codigo == tipo_mov select t;
                tipo = lista2.FirstOrDefault<TipoMovimiento>().tipo;

                mov.tipo_mov = tipo_mov;
                mov.articulo = articulo;
                mov.cantidad = cantidad;
                mov.precio_iva = art.precio_iva;
                mov.fecha = DateTime.Now;

                context.Movimiento.AddObject(mov);

                if (tipo == "E")
                    cant_nueva = art.stock + cantidad;
                else
                    cant_nueva = art.stock - cantidad;
                    
                int result = articuloBL.UpdateCantidadArticulo(articulo, cant_nueva);

                if (result != 0)
                    return context.SaveChanges();
                else
                    return 0;
            }
            catch (Exception)
            {
                return 0;
            }
        }

        public int InsertMovimientoTx(string tipo_mov, string articulo, int cantidad)
        {
            Movimiento mov = new Movimiento();
            Articulo art = new Articulo();
            ArticuloBL articuloBL = new ArticuloBL();
            string tipo = "";
            int cant_nueva = 0;

            try
            {
                var lista = from a in context.Articulo where a.codigo == articulo select a;
                art = lista.FirstOrDefault<Articulo>();

                var lista2 = from t in context.TipoMovimiento where t.codigo == tipo_mov select t;
                tipo = lista2.FirstOrDefault<TipoMovimiento>().tipo;

                mov.tipo_mov = tipo_mov;
                mov.articulo = articulo;
                mov.cantidad = cantidad;
                mov.precio_iva = art.precio_iva;
                mov.fecha = DateTime.Now;

                context.Movimiento.AddObject(mov);

                if (tipo == "E")
                    cant_nueva = art.stock + cantidad;
                else
                    cant_nueva = art.stock - cantidad;

                int result = articuloBL.UpdateCantidadArticulo(articulo, cant_nueva);

                if (result != 0)
                    return 1;
                else
                    return 0;
            }
            catch (Exception)
            {
                return 0;
            }
        }

    }
}
