﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Entitats;
using System.Net.Mail;
using System.Net;

namespace Negoci
{
    public class PedidoBL
    {

        private SaisOnlineEntities context;

        public PedidoBL()
        {
            context = new SaisOnlineEntities();
        }

        public int AgregarPedido(Pedido pedido)
        {
            context.Pedido.AddObject(pedido);
            return context.SaveChanges();
        }

        public Pedido GetPedidoPdteByUsuario(string usuario)
        {
            Pedido ped = new Pedido();
            try
            {
                //Falta mirar PedidoEstado
                var pedido = from p in context.Pedido where p.usuario == usuario && p.estado == "P" select p;
                ped = pedido.FirstOrDefault<Pedido>();
            }
            catch (Exception)
            {

            }
            return ped;
        }

        public void ActualizarCantidadPedidoLin(int id, int cantidad)
        {
            PedidoLin ped = new PedidoLin();
            try
            {
                var pedido = from p in context.PedidoLin where p.id_pedido_lin == id select p;
                ped = pedido.FirstOrDefault<PedidoLin>();

                ped.cantidad = cantidad;

                context.SaveChanges();
            }
            catch (Exception)
            {

            }
        }

        public void EliminarPedidoLin(int id, bool envio)
        {
            try
            {
                PedidoLin ped = new PedidoLin();
                var pedido = from p in context.PedidoLin where p.id_pedido_lin == id select p;
                ped = pedido.FirstOrDefault<PedidoLin>();

                context.PedidoLin.DeleteObject(ped);

                if (envio)
                {
                    PedidoLin env = new PedidoLin();
                    var enviolin = from p in context.PedidoLin where p.pedido == ped.pedido && p.articulo == "ENVIO" select p;
                    env = enviolin.FirstOrDefault<PedidoLin>();

                    context.PedidoLin.DeleteObject(env);
                }

                context.SaveChanges();
            }
            catch (Exception)
            {

            }
        }

        public int InsertPedido(string login)
        {
            try
            {
                Pedido ped = new Pedido();
                ped.usuario = login;
                ped.fecha = DateTime.Now;
                ped.estado = "P";

                PedidoEstado pedest = new PedidoEstado();
                pedest.estado = "P";
                pedest.fecha = DateTime.Now;

                List<PedidoEstado> list_est = new List<PedidoEstado>();
                list_est.Add(pedest);

                ped.PedidoEstado = list_est;

                context.Pedido.AddObject(ped);

                context.SaveChanges();

                return ped.numero;
            }
            catch (Exception)
            {
                return 0;
            }
        }

        public int InsertPedido(string login, List<PedidoLin> lista)
        {
            try
            {
                Pedido ped = new Pedido();
                ped.usuario = login;
                ped.fecha = DateTime.Now;
                ped.estado = "P";
                ped.PedidoLin = lista;

                PedidoEstado pedest = new PedidoEstado();
                pedest.estado = "P";
                pedest.fecha = DateTime.Now;

                List<PedidoEstado> list_est = new List<PedidoEstado>();
                list_est.Add(pedest);

                ped.PedidoEstado = list_est;

                context.Pedido.AddObject(ped);

                context.SaveChanges();

                return ped.numero;
            }
            catch (Exception)
            {
                return 0;
            }
        }

        //public int InsertPedidoLin(int numero, List<PedidoLin> lista)
        //{
        //    try
        //    {
        //        var pedido = from p in context.Pedido
        //                     where p.numero == numero
        //                     select p;

        //        Pedido ped = pedido.FirstOrDefault();
        //        ped.PedidoLin = lista;


        //        context.SaveChanges();

        //        return ped.numero;
        //    }
        //    catch (Exception)
        //    {
        //        return 0;
        //    }
        //}

        public int DeletePedido(int numero)
        {
            try
            {
                var pedido = from p in context.Pedido where p.numero == numero select p;

                Pedido ped = pedido.FirstOrDefault<Pedido>();

                List<PedidoEstado> lpe = ped.PedidoEstado.ToList();
                List<PedidoLin> lpl = ped.PedidoLin.ToList();

                foreach (PedidoEstado pe in lpe)
                {
                    context.PedidoEstado.DeleteObject(pe);
                }

                foreach (PedidoLin pl in lpl)
                {
                    context.PedidoLin.DeleteObject(pl);
                }

                context.Pedido.DeleteObject(ped);

                return context.SaveChanges();
            }
            catch (Exception)
            {
                return 0;
            }
        }

        public int InsertPedidoLin(int pedido, string articulo, int cantidad, decimal precio_iva, decimal descuento, bool envio)
        {
            try
            {
                PedidoLin linea = new PedidoLin();
                linea.pedido = pedido;
                linea.articulo = articulo;
                linea.cantidad = cantidad;
                linea.precio_iva = precio_iva;
                linea.descuento = descuento;

                context.PedidoLin.AddObject(linea);

                if (envio)
                {
                    ArticuloBL articulobl = new ArticuloBL();
                    Articulo envart = articulobl.GetArticuloByCodigo("ENVIO");

                    PedidoLin env = new PedidoLin();
                    env.pedido = pedido;
                    env.articulo = envart.codigo;
                    env.cantidad = 1;
                    env.precio_iva = envart.precio_iva;
                    env.descuento = 0;

                    context.PedidoLin.AddObject(env);
                }

                context.SaveChanges();

                //Buscamos el id del articulo que acabamos de crear:
                int id_pedido_lin = (from p in context.PedidoLin where p.pedido == pedido & p.articulo == articulo select p).FirstOrDefault<PedidoLin>().id_pedido_lin;
                return id_pedido_lin;
            }
            catch (Exception)
            {
                return 0;
            }
        }

        public List<PedidoLin> GetPedidoLinPdteByUsuario(string usuario)
        {
            List<PedidoLin> lista = new List<PedidoLin>();

            List<PedidoLin> lista2 = new List<PedidoLin>();
            try
            {
                //Falta mirar PedidoEstado

                var pedidolin =
                    from l in context.PedidoLin
                    join p in context.Pedido
                    on l.pedido equals p.numero
                    where p.usuario == usuario
                    && p.estado == "P"
                    orderby l.precio_iva descending
                    select l;

                lista = pedidolin.ToList<PedidoLin>();

                foreach (PedidoLin pedlin in lista)
                {
                    PedidoLin pl = new PedidoLin();
                    pl.id_pedido_lin = pedlin.id_pedido_lin;
                    pl.articulo = pedlin.articulo;
                    pl.cantidad = pedlin.cantidad;
                    pl.descuento = pedlin.descuento;
                    pl.pedido = pedlin.pedido;
                    pl.precio_iva = pedlin.precio_iva;
                    lista2.Add(pl);
                }

            }
            catch (Exception)
            {

            }
            return lista2;
        }

        public int GetNumPdteByUsuario(string usuario)
        {
            try
            {
                //Falta mirar PedidoEstado

                var pedido =
                    from p in context.Pedido
                    where p.usuario == usuario
                    && p.estado == "P"
                    select p;

                return pedido.FirstOrDefault<Pedido>().numero;

            }
            catch (Exception)
            {
                return 0;
            }
        }

        public decimal GetTotalByPedido(int numero)
        {
            decimal total = 0;

            List<PedidoLin> lista = new List<PedidoLin>();
            try
            {
                //Falta mirar PedidoEstado
                var pedidolin =
                    from l in context.PedidoLin
                    where l.pedido == numero
                    select l;

                lista = pedidolin.ToList<PedidoLin>();

                foreach (PedidoLin pedlin in lista)
                {
                    total = (total + pedlin.precio_iva);
                }
            }
            catch (Exception ex)
            {

            }
            return total;


        }
        public int FacturarPedido(string login)
        {
            try
            {
                //Facturar el pedido
                Pedido ped = this.GetPedidoPdteByUsuario(login);
                ped.estado = "F";

                PedidoEstado pedest = new PedidoEstado();
                pedest.pedido = ped.numero;
                pedest.fecha = DateTime.Now;
                pedest.estado = "F";

                ped.PedidoEstado.Add(pedest);

                if (GenerarFactura(ped) == 1)
                {
                    enviarMailCliente(ped);
                    enviarMailAdm(ped);
                    return context.SaveChanges();
                }
                else
                    return 0;
            }
            catch (Exception)
            {
                return 0;
            }
        }

        private void enviarMailCliente(Pedido pedido)
        {
            MailMessage msg = new MailMessage();
            msg.Subject = String.Format("Gracias por su compra en Sais Online");
            UsuarioBL usuariobl = new UsuarioBL();

            Cliente cliente = usuariobl.GetClienteByLogin(pedido.usuario);
            msg.To.Add(new MailAddress(cliente.email));
            msg.From = new MailAddress("saisonlineadm@yahoo.es", "Sais Online");
            msg.Body = string.Format("Pedido {0} realizado con éxito.", pedido.numero);
            msg.Body += Environment.NewLine;
            msg.Body += (string.Format("Puede consultar sus facturas en la web."));
            SmtpClient server = new SmtpClient("smtp.mail.yahoo.com", 25);
            server.Credentials = new NetworkCredential("saisonlineadm", "52545254");
            server.EnableSsl = false;
            server.Send(msg);

        }

        private void enviarMailAdm(Pedido pedido)
        {
            UsuarioBL usuariobl = new UsuarioBL();
            foreach (Usuario usu in usuariobl.GetUsuariosAdmin())
            {
                UsuarioBL usubl = new UsuarioBL();
                Cliente cliente = usubl.GetClienteByLogin(usu.login);
                MailMessage msg = new MailMessage();
                msg.Subject = String.Format("Nueva compra");
                msg.To.Add(new MailAddress(cliente.email));
                msg.From = new MailAddress("saisonlineadm@yahoo.es", "Sais Online");
                msg.Body = string.Format("Pedido {0} realizado con éxito.", pedido.numero);
                SmtpClient server = new SmtpClient("smtp.mail.yahoo.com", 25);
                server.Credentials = new NetworkCredential("saisonlineadm", "52545254");
                server.EnableSsl = false;
                server.Send(msg);
            }

        }
        public int GenerarFactura(Pedido pedido)
        {
            try
            {
                UsuarioBL usuarioBL = new UsuarioBL();
                Cliente cli = usuarioBL.GetClienteByLogin(pedido.usuario);
                Factura factura = new Factura();
                factura.cliente = cli.dni;
                factura.fecha = DateTime.Now;
                factura.pedido = pedido.numero;
                foreach (PedidoLin pedlin in pedido.PedidoLin.ToList<PedidoLin>())
                {
                    FacturaLin flin = new FacturaLin();
                    flin.articulo = pedlin.articulo;
                    flin.cantidad = pedlin.cantidad;
                    flin.descuento = pedlin.descuento;
                    flin.precio_iva = pedlin.precio_iva;
                    flin.factura = factura.numero;
                    factura.FacturaLin.Add(flin);

                    ArticuloBL articulobl = new ArticuloBL();
                    Articulo art = articulobl.GetArticuloByCodigo(pedlin.articulo);

                    bool existeIva = false;

                    if (art.codigo != "ENVIO")
                    {
                        MovimientoBL movimbl = new MovimientoBL(context);
                        if (movimbl.InsertMovimientoTx("V", art.codigo, pedlin.cantidad) != 1)
                        {
                            return 0;
                        }
                    }

                    foreach (FacturaIva fi in factura.FacturaIva.ToList<FacturaIva>())
                    {
                        if (art.tipo_iva == fi.tipo_iva)
                        {
                            existeIva = true;
                            decimal totIva = Math.Round(flin.cantidad * flin.precio_iva, 2);
                            decimal total = Math.Round((totIva * 100 / (100 + art.TipoIva.porcentaje)), 2);
                            fi.impbase = fi.impbase + total;
                            fi.iva = fi.iva + (totIva - total);
                        }

                    }

                    if (!existeIva)
                    {
                        FacturaIva fiva = new FacturaIva();
                        fiva.tipo_iva = art.tipo_iva;
                        fiva.impbase = Math.Round((pedlin.cantidad * pedlin.precio_iva * 100 / (100 + art.TipoIva.porcentaje)), 2);
                        fiva.iva = Math.Round(pedlin.precio_iva * pedlin.cantidad, 2) - fiva.impbase;
                        fiva.factura = factura.numero;
                        factura.FacturaIva.Add(fiva);
                    }

                }

                context.Factura.AddObject(factura);

                return 1;
            }
            catch (Exception)
            {
                return 0;
            }

        }
    }
}
