﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Entitats;

namespace Negoci
{
    public class UsuarioBL
    {
        //Entitats.SaisOnlineEntities m_Context = new SaisOnlineEntities();

        //public Entitats.SaisOnlineEntities Context
        //{

        //    get { return m_Context; }
        //    set { m_Context = value; }
        //}

        private SaisOnlineEntities context;

        public UsuarioBL()
        {
            context = new SaisOnlineEntities();
        }

        public int AgregarUsuario(Usuario usuario)
        {
            try
            {
                context.Usuario.AddObject(usuario);
                return context.SaveChanges();
            }
            catch (Exception)
            {
                return 0;
            }
        }

        public bool isAdministrador(String login)
        {
            var consulta = from u in context.Usuario where u.login == login select u.Perfil1.codigo;
            string perfil = consulta.FirstOrDefault();

            if (perfil == "A")
                return true;
            else
                return false;
        }

        public bool isCliente(string login)
        {
            Cliente cli = new Cliente();
            var consulta = from c in context.Cliente where c.login == login select c;
            cli = consulta.FirstOrDefault<Cliente>();

            if (cli == null)
                return false;
            else
                return true;
        }

        public List<viewCliente> GetViewClientesByPerfilDni(string perfil, string dni)
        {
            List<viewCliente> lista = new List<viewCliente>();
            try
            {
                if (dni == "")
                {
                    var clientes = from c in context.viewCliente where c.perfil == perfil select c;
                    lista = clientes.ToList();
                }
                else
                {
                    var clientes = from c in context.viewCliente where c.perfil == perfil & c.dni==dni select c;
                    lista = clientes.ToList();
                }

            }
            catch (Exception)
            {
                return lista;
            }
            return lista;
        }

        public int InsertCliente(string dni, string login, string nombre, string apellido1, string apellido2,
            string tipo_via, string direccion, string cp, string poblacion, string pais,
            string tipo_via_env, string direccion_env, string cp_env, string poblacion_env, string pais_env,
            string telefono, string movil, string email)
        {
            Cliente cli = new Cliente();
            try
            {
                cli.dni = dni;
                cli.login = login;
                cli.nombre = nombre;
                cli.apellido1 = apellido1;
                cli.apellido2 = apellido2;
                cli.tipo_via = tipo_via;
                cli.direccion = direccion;
                cli.cp = cp;
                cli.poblacion = poblacion;
                cli.pais = pais;
                cli.tipo_via_env = tipo_via_env;
                cli.direccion_env = direccion_env;
                cli.cp_env = cp_env;
                cli.poblacion_env = poblacion_env;
                cli.pais_env = pais_env;
                cli.telefono = telefono;
                cli.movil = movil;
                cli.email = email;

                context.Cliente.AddObject(cli);

                return context.SaveChanges();
            }
            catch (Exception)
            {
                return 0;
            }
        }

        public int UpdateCliente(string dni, string login, string nombre, string apellido1, string apellido2,
            string tipo_via, string direccion, string cp, string poblacion, string pais,
            string tipo_via_env, string direccion_env, string cp_env, string poblacion_env, string pais_env,
            string telefono, string movil, string email)
        {
            Cliente cli = new Cliente();
            try
            {
                var obj = from c in context.Cliente where c.login == login select c;

                cli = obj.FirstOrDefault<Cliente>();

                cli.dni = dni;
                cli.nombre = nombre;
                cli.apellido1 = apellido1;
                cli.apellido2 = apellido2;
                cli.tipo_via = tipo_via;
                cli.direccion = direccion;
                cli.cp = cp;
                cli.poblacion = poblacion;
                cli.pais = pais;
                cli.tipo_via_env = tipo_via_env;
                cli.direccion_env = direccion_env;
                cli.cp_env = cp_env;
                cli.poblacion_env = poblacion_env;
                cli.pais_env = pais_env;
                cli.telefono = telefono;
                cli.movil = movil;
                cli.email = email;

                return context.SaveChanges();
            }
            catch (Exception)
            {
                return 0;
            }
        }

        public int CambiarPassword(string login, string password)
        {
            Usuario user = new Usuario();
            try
            {
                var obj = from u in context.Usuario where u.login == login select u;

                user = obj.FirstOrDefault<Usuario>();

                user.password = password;

                return context.SaveChanges();
            }
            catch (Exception)
            {
                return 0;
            }
        }

        public int UpdateUsuario(string login, string perfil)
        {
            Usuario us = new Usuario();
            try
            {
                var obj = from u in context.Usuario where u.login == login select u;

                us = obj.FirstOrDefault<Usuario>();

                us.perfil = perfil;
                
                return context.SaveChanges();
            }
            catch (Exception)
            {
                return 0;
            }
        }

        public Cliente GetClienteByLogin(string login)
        {
            Cliente cli = new Cliente();
            try
            {
                var cliente = from c in context.Cliente where c.login == login select c;

                cli = cliente.FirstOrDefault<Cliente>();
            }
            catch (Exception)
            {
                return cli;
            }
            return cli;
        }

        public Usuario GetUsuarioByLogin(string login)
        {
            Usuario us = new Usuario();
            try
            {
                var usuario = from u in context.Usuario where u.login == login select u;

                us = usuario.FirstOrDefault<Usuario>();
            }
            catch (Exception)
            {
                return us;
            }
            return us;
        }

        public List<Usuario> GetUsuariosAdmin()
        {
            List<Usuario> us = new List<Usuario>();
            try
            {
                var usuario = from u in context.Usuario where u.perfil == "A" select u;

                us = usuario.ToList<Usuario>();
            }
            catch (Exception)
            {
                return us;
            }
            return us;
        }

    }
}
