﻿<%@ Page Title="Cambiar contraseña" Language="C#" MasterPageFile="~/Site.master"
    AutoEventWireup="true" CodeBehind="ChangePassword.aspx.cs" Inherits="Web.Account.ChangePassword" %>

<asp:Content ID="HeaderContent" runat="server" ContentPlaceHolderID="HeadContent">
</asp:Content>
<asp:Content ID="BodyContent" runat="server" ContentPlaceHolderID="MainContent">
    <div class="main">
        <asp:Panel ID="pnlMessage" runat="server" Visible="false" BackColor="#FFFFCC" BorderColor="Gray"
            BorderWidth="1px">
            <br />
            &nbsp;
            <asp:Image ID="imgError" runat="server" ImageUrl="~/icons/exclamation.png" />
            &nbsp;
            <asp:Label ID="lblMessage" runat="server" ForeColor="Red" Font-Bold="True"></asp:Label>
            <br />
            <br />
        </asp:Panel>
        <table width="100%">
            <tr>
                <td valign="top" width="15%">
                </td>
                <td>
                    <h2>
                        Cambiar contraseña
                    </h2>
                    <p>
                        Use el formulario siguiente para cambiar la contraseña.
                    </p>
                    <p>
                        Las contraseñas nuevas deben tener una longitud mínima de
                        <%= Membership.MinRequiredPasswordLength %>
                        caracteres.
                    </p>
                    <asp:ChangePassword ID="ChangeUserPassword" runat="server" CancelDestinationPageUrl="~/MiCuenta.aspx?op=old&comp=0"
                        EnableViewState="false" RenderOuterTable="false" OnChangedPassword="ChangeUserPassword_ChangedPassword">
                        <ChangePasswordTemplate>
                            <span class="failureNotification">
                                <asp:Literal ID="FailureText" runat="server"></asp:Literal>
                            </span>
                            <asp:ValidationSummary ID="ChangeUserPasswordValidationSummary" runat="server" CssClass="failureNotification"
                                ValidationGroup="ChangeUserPasswordValidationGroup" />
                            <div class="accountInfo">
                                <fieldset class="changePassword">
                                    <legend>Información de cuenta</legend>
                                    <p>
                                        <asp:Label ID="CurrentPasswordLabel" runat="server" AssociatedControlID="CurrentPassword">Contraseña anterior:</asp:Label>
                                        <asp:TextBox ID="CurrentPassword" runat="server" CssClass="passwordEntry" TextMode="Password"></asp:TextBox>
                                        <asp:RequiredFieldValidator ID="CurrentPasswordRequired" runat="server" ControlToValidate="CurrentPassword"
                                            CssClass="failureNotification" ErrorMessage="La contraseña es obligatoria." ToolTip="La contraseña anterior es obligatoria."
                                            ValidationGroup="ChangeUserPasswordValidationGroup">*</asp:RequiredFieldValidator>
                                    </p>
                                    <p>
                                        <asp:Label ID="NewPasswordLabel" runat="server" AssociatedControlID="NewPassword">Nueva contraseña:</asp:Label>
                                        <asp:TextBox ID="NewPassword" runat="server" CssClass="passwordEntry" TextMode="Password"></asp:TextBox>
                                        <asp:RequiredFieldValidator ID="NewPasswordRequired" runat="server" ControlToValidate="NewPassword"
                                            CssClass="failureNotification" ErrorMessage="La nueva contraseña es obligatoria."
                                            ToolTip="La nueva contraseña es obligatoria." ValidationGroup="ChangeUserPasswordValidationGroup">*</asp:RequiredFieldValidator>
                                    </p>
                                    <p>
                                        <asp:Label ID="ConfirmNewPasswordLabel" runat="server" AssociatedControlID="ConfirmNewPassword">Confirmar la nueva contraseña:</asp:Label>
                                        <asp:TextBox ID="ConfirmNewPassword" runat="server" CssClass="passwordEntry" TextMode="Password"></asp:TextBox>
                                        <asp:RequiredFieldValidator ID="ConfirmNewPasswordRequired" runat="server" ControlToValidate="ConfirmNewPassword"
                                            CssClass="failureNotification" Display="Dynamic" ErrorMessage="Confirmar la nueva contraseña es obligatorio."
                                            ToolTip="Confirmar la nueva contraseña es obligatorio." ValidationGroup="ChangeUserPasswordValidationGroup">*</asp:RequiredFieldValidator>
                                        <asp:CompareValidator ID="NewPasswordCompare" runat="server" ControlToCompare="NewPassword"
                                            ControlToValidate="ConfirmNewPassword" CssClass="failureNotification" Display="Dynamic"
                                            ErrorMessage="Confirmar la nueva contraseña debe coincidir con la entrada Nueva contraseña."
                                            ValidationGroup="ChangeUserPasswordValidationGroup">*</asp:CompareValidator>
                                    </p>
                                </fieldset>
                                <p class="submitButton">
                                    <asp:Button ID="CancelPushButton" runat="server" CausesValidation="False" CommandName="Cancel"
                                        Text="Cancelar" />
                                    <asp:Button ID="ChangePasswordPushButton" runat="server" CommandName="ChangePassword"
                                        Text="Cambiar contraseña" ValidationGroup="ChangeUserPasswordValidationGroup" />
                                </p>
                            </div>
                        </ChangePasswordTemplate>
                    </asp:ChangePassword>
                </td>
            </tr>
        </table>
    </div>
</asp:Content>
