﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

using Negoci;
using Entitats;

namespace Web.Account
{
    public partial class Login : System.Web.UI.Page
    {

        #region Propiedades de la Clase

        protected static List<PedidoLin> listaLin
        {
            get { return (List<PedidoLin>)HttpContext.Current.Session["listalin"]; }
            set
            {
                HttpContext.Current.Session["listalin"] = value;
            }
        }

        protected static int Num_pedido
        {
            get { return (int)HttpContext.Current.Session["num_pedido"]; }
            set { HttpContext.Current.Session["num_pedido"] = value; }
        }

        #endregion

        protected void Page_Load(object sender, EventArgs e)
        {
            RegisterHyperLink.NavigateUrl = "Register.aspx?ReturnUrl=" + HttpUtility.UrlEncode(Request.QueryString["ReturnUrl"]);
        }

        protected void LoginUser_LoggedIn(object sender, EventArgs e)
        {
            Session.Add("userlogin", LoginUser.UserName);

            //Miramos si ya tenia pedido pendiente:
            PedidoBL pedidobl = new PedidoBL();
            List<PedidoLin> lista = pedidobl.GetPedidoLinPdteByUsuario(LoginUser.UserName);
            if (lista.Count>0)
                listaLin = lista;
            else
            { 
                //Miramos si ya habia lineas en el carrito antes de identificarse
                if (listaLin.Count > 0)
                { 
                    //Creamos el pedido
                    PedidoBL newped = new PedidoBL();
                    Num_pedido = newped.InsertPedido((string)(HttpContext.Current.Session["userlogin"]),listaLin);
                }
            }
        }


    }
}
