﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;

using Entitats;
using Negoci;

namespace Web.Account
{
    public partial class Register : System.Web.UI.Page
    {

        #region Propiedades de la Clase

        protected List<PedidoLin> listaLin
        {
            get { return (List<PedidoLin>)Session["listalin"]; }
            set { Session["listalin"] = value; }
        }

        protected int Num_pedido
        {
            get { return (int)Session["num_pedido"]; }
            set { Session["num_pedido"] = value; }
        }

        #endregion

        protected void Page_Load(object sender, EventArgs e)
        {
            RegisterUser.ContinueDestinationPageUrl = Request.QueryString["ReturnUrl"];
        }

        protected void RegisterUser_CreatedUser(object sender, EventArgs e)
        {
            FormsAuthentication.SetAuthCookie(RegisterUser.UserName, false /* createPersistentCookie */);

            Session.Add("userlogin", RegisterUser.UserName);

            //Guardamos el usuario en SaisOnline
            Usuario usuario = new Usuario();
            usuario.login = RegisterUser.UserName;
            usuario.password = RegisterUser.Password;
            usuario.perfil = "C";

            UsuarioBL usuarioBL = new UsuarioBL();
            usuarioBL.AgregarUsuario(usuario);

            Session["userlogin"] = usuario.login;

            //Si hay algo en el carrito, creamos el pedido con las líneas
            if (listaLin.Count != 0)
            {
                PedidoBL pedidobl = new PedidoBL();
                Session["num_pedido"] = pedidobl.InsertPedido(Session["userlogin"].ToString(), listaLin);
            }


            string isCompra = Session["comp"].ToString();
            Session["comp"] = 0;

            Response.Redirect("~/MiCuenta.aspx?op=new&comp=" + isCompra);
        }

        protected void btnCopiarDir_Click(object sender, EventArgs e)
        {
            string tipo_via = ((DropDownList)RegisterUser.FindControl("ddlTipoVia")).SelectedValue;
            string direccion = ((TextBox)RegisterUser.FindControl("tbDireccion")).Text;
            string cp = ((TextBox)RegisterUser.FindControl("tbCp")).Text;
            string pob = ((TextBox)RegisterUser.FindControl("tbPob")).Text;
            string pais = ((TextBox)RegisterUser.FindControl("tbPais")).Text;

            ((DropDownList)RegisterUser.FindControl("ddlTipoViaEnv")).SelectedValue = tipo_via;
            ((TextBox)RegisterUser.FindControl("tbDireccionEnv")).Text = direccion;
        }
    }
}
