﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

using System.Web.Security;
using System.Web.Services;

using Negoci;
using Entitats;

namespace Web
{
    public partial class Contacto : System.Web.UI.Page
    {
        #region WebMethods

        [WebMethod]
        public static int addCantidad(string codigo)
        {
            int result = 1;
            try
            {
                List<PedidoLin> carrito = (List<PedidoLin>)(HttpContext.Current.Session["listalin"]);
                int id_pedido_lin = 0;
                int cantidad_nueva = 0;

                PedidoBL pedidobl = new PedidoBL();
                ArticuloBL articulobl = new ArticuloBL();

                foreach (PedidoLin pl in carrito)
                {
                    if (pl.articulo == codigo)
                    {
                        id_pedido_lin = pl.id_pedido_lin;

                        cantidad_nueva = pl.cantidad + 1;
                        pl.cantidad = cantidad_nueva;
                        break;
                    }
                }

                //Si está identificado, lo guardamos en bbdd
                if ((string)(HttpContext.Current.Session["userlogin"]) != "")
                {
                    if (id_pedido_lin != 0)
                        pedidobl.ActualizarCantidadPedidoLin(id_pedido_lin, cantidad_nueva);
                }

                HttpContext.Current.Session["listalin"] = carrito;
            }
            catch
            {
                result = 0;
            }
            return result;
        }

        [WebMethod]
        public static int restarCantidad(string codigo)
        {
            int result = 1;
            bool envio = false;
            try
            {
                List<PedidoLin> carrito = (List<PedidoLin>)(HttpContext.Current.Session["listalin"]);
                int existe = 0;
                int cantidad_nueva = 0;

                PedidoBL pedidobl = new PedidoBL();
                ArticuloBL articulobl = new ArticuloBL();

                foreach (PedidoLin pl in carrito)
                {
                    if (pl.articulo == codigo)
                    {
                        existe = pl.id_pedido_lin;

                        cantidad_nueva = pl.cantidad - 1;
                        if (cantidad_nueva != 0)
                            pl.cantidad = cantidad_nueva;
                        else
                        {
                            //Si borramos el ultimo articulo, quitamos tambien el envío
                            if (carrito.Count != 1)
                                carrito.Remove(pl);
                            else
                            {
                                envio = true;
                                carrito = new List<PedidoLin>();
                            }
                        }

                        break;
                    }
                }

                //Si está identificado, lo guardamos en bbdd
                if ((string)(HttpContext.Current.Session["userlogin"]) != "")
                {
                    if (existe != 0)
                    {
                        //Si la cantidad actual es zero, borramos la línea
                        if (cantidad_nueva != 0)
                            pedidobl.ActualizarCantidadPedidoLin(existe, cantidad_nueva);
                        else
                            pedidobl.EliminarPedidoLin(existe, envio);
                    }
                }

                HttpContext.Current.Session["listalin"] = carrito;
            }
            catch
            {
                result = 0;
            }
            return result;
        }

        #endregion

        #region Propiedades de la Clase

        protected List<PedidoLin> listaLin
        {
            get { return (List<PedidoLin>)Session["listalin"]; }
            set { Session["listalin"] = value; }
        }

        protected int Num_pedido
        {
            get { return (int)Session["num_pedido"]; }
            set { Session["num_pedido"] = value; }
        }

        #endregion

        protected void Page_Load(object sender, EventArgs e)
        {
            //La primera vez
            if (!IsPostBack)
            {
                string userlogin = Session["userlogin"].ToString();

                //Actualizar carrito
                cargarCarrito();
            }

            //Cargar Menú según las categorías
            cargarMenu();
        }

        //Funcion para Cargar el Menú
        private void cargarMenu()
        {
            CategoriaBL catBL = new CategoriaBL();
            List<Categoria> categorias = new List<Categoria>();
            categorias = catBL.GetCategoriasNoEnvio();

            foreach (Categoria c in categorias)
            {
                MenuItem mi = new MenuItem();
                mi.NavigateUrl = "~/ListArticulos.aspx?cat=" + c.codigo;
                mi.Text = c.descripcion;
                menu.Items.Add(mi);
            }
        }

        //Funcion para Cargar el Carrito
        private void cargarCarrito()
        {
            string userlogin = Session["userlogin"].ToString();

            if (userlogin != "")
            {
                PedidoBL pedidobl = new PedidoBL();

                listaLin = pedidobl.GetPedidoLinPdteByUsuario(Session["userlogin"].ToString());
                Num_pedido = pedidobl.GetNumPdteByUsuario(Session["userlogin"].ToString());
            }
            else
            {
                listaLin = new List<PedidoLin>();
                Num_pedido = -1;
            }

            gvPedidoLin.DataSource = listaLin;
            gvPedidoLin.DataBind();
        }

        //Funcion para Cargar el Total del Carrito
        protected void cargarTotal()
        {
            decimal total = 0;

            if (listaLin.Count > 0)
            {
                lblNoHayLin.Visible = false;
                lblTotal.Visible = true;
                btnComprar.Visible = true;

                foreach (PedidoLin ped_lin in listaLin)
                {
                    total += (ped_lin.precio_iva * ped_lin.cantidad);
                }

                lblTotal.Text = "TOTAL Compra " + total.ToString() + "€";
            }
            else
            {
                lblNoHayLin.Visible = true;
                lblTotal.Visible = false;
                btnComprar.Visible = false;
            }
        }

        protected string btnAddCant(Object articulo)
        {
            string cadena = "";
            if (articulo.ToString() != "ENVIO")
                cadena = @"<a onclick=""btnAddCantClick('" + articulo + @"')""><img alt='Añadir' src='../icons/add.png' /></a>";

            return cadena;
        }

        protected string btnElimCant(Object articulo)
        {
            string cadena = "";
            if (articulo.ToString() != "ENVIO")
                cadena = @"<a onclick=""btnEliminarCantClick('" + articulo + @"')""><img alt='Eliminar' src='../icons/delete.png' /></a>";

            return cadena;
        }

        protected void UpdatePanel1_Load(object sender, EventArgs e)
        {
            cargarTotal();
            gvPedidoLin.DataSource = listaLin;
            gvPedidoLin.DataBind();
        }

        protected void btnComprar_Click(object sender, EventArgs e)
        {
            string login = Session["userlogin"].ToString();

            //Si está identificado
            if (login != "")
            {
                //Comprobar datos de cliente
                UsuarioBL usuarioBL = new UsuarioBL();

                if (usuarioBL.isCliente(login))
                {
                    //Si ya tiene los datos personales, hacemos la factura
                    PedidoBL pedidobl = new PedidoBL();
                    pedidobl.FacturarPedido(login);
                }
                else
                {
                    //Sino, lo redirigimos para que introduzca sus datos personales
                    Response.Redirect("~/MiCuenta.aspx?op=new&comp=1");
                }
            }
            else
            {
                //Redireccionar para que se registre o identifique
                Session["comp"] = 1;
                Response.Redirect("~/Account/Login.aspx");
            }

            cargarCarrito();
            cargarTotal();
        }
    }
}