﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

using Entitats;

namespace Web
{
    public partial class MantArticuloDetalle : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                string op = Request.Params["op"];

                if (op == "edit")
                {
                    fvArticulo.DefaultMode = FormViewMode.Edit;
                    fvArticulo.DataBind();

                    //Cargamos el combo de la categoría
                    ((DropDownList)(fvArticulo.FindControl("ddlCategoria"))).SelectedValue = ((TextBox)(fvArticulo.FindControl("categoriaTextBox"))).Text;

                    //Cargamos el combo del tipo de iva
                    ((DropDownList)(fvArticulo.FindControl("ddlTipoIva"))).SelectedValue = ((TextBox)(fvArticulo.FindControl("tipo_ivaTextBox"))).Text;

                }
                else if (op == "new")
                {
                    fvArticulo.DefaultMode = FormViewMode.Insert;
                }
            }            
        }

        protected void odsArticulo_Selecting(object sender, ObjectDataSourceSelectingEventArgs e)
        {
            string cod = Request.Params["cod"];

            e.InputParameters["codigo"] = cod;
        }

        protected void odsArticulo_Updated(object sender, ObjectDataSourceStatusEventArgs e)
        {
            if (Convert.ToInt32(e.ReturnValue) != 0)
                Response.Redirect("MantArticulos.aspx");
            else
            {
                pnlMessage.Visible = true;
                lblMessage.Text = "Error al modificar el artículo";
            }
        }

        protected void odsArticulo_Inserted(object sender, ObjectDataSourceStatusEventArgs e)
        {
            if (Convert.ToInt32(e.ReturnValue) != 0)
                Response.Redirect("MantArticulos.aspx");
            else 
            {
                pnlMessage.Visible = true;
                lblMessage.Text = "Error al insertar el artículo";
            }
        }

        protected void odsArticulo_Updating(object sender, ObjectDataSourceMethodEventArgs e)
        {
            e.InputParameters["categoria"] = ((DropDownList)(fvArticulo.FindControl("ddlCategoria"))).SelectedValue;
            e.InputParameters["tipo_iva"] = ((DropDownList)(fvArticulo.FindControl("ddlTipoIva"))).SelectedValue;
        }

        protected void odsArticulo_Inserting(object sender, ObjectDataSourceMethodEventArgs e)
        {
            e.InputParameters["categoria"] = ((DropDownList)(fvArticulo.FindControl("ddlCategoria"))).SelectedValue;
            e.InputParameters["tipo_iva"] = ((DropDownList)(fvArticulo.FindControl("ddlTipoIva"))).SelectedValue;
        }

        protected void UpdateCancelButton_Click(object sender, EventArgs e)
        {
            Response.Redirect("MantArticulos.aspx");
        }

        protected void InsertCancelButton_Click(object sender, EventArgs e)
        {
            Response.Redirect("MantArticulos.aspx");
        }

        protected void odsArticulo_Deleted(object sender, ObjectDataSourceStatusEventArgs e)
        {
            if (Convert.ToInt32(e.ReturnValue) != 0)
                Response.Redirect("MantArticulos.aspx");
            else
            {
                pnlMessage.Visible = true;
                lblMessage.Text = "Error al eliminar el artículo";
            }
        }

        protected void odsArticulo_Deleting(object sender, ObjectDataSourceMethodEventArgs e)
        {
            e.InputParameters["codigo"] = ((TextBox)(fvArticulo.FindControl("codigoTextBox"))).Text;
        }
    }
}