﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Negoci;

namespace Web
{
    public partial class MiCuenta : System.Web.UI.Page
    {
        
        
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                string login = Session["userlogin"].ToString();
                string op = Request.Params["op"].ToString();
                string comp = Request.Params["comp"].ToString();

                bool nuevo = true;
                UsuarioBL usuarioBL = new UsuarioBL();
                if (usuarioBL.GetClienteByLogin(login) != null)
                    nuevo = false;


                if (!nuevo)
                {
                    fvCliente.DefaultMode = FormViewMode.Edit;
                    fvCliente.DataBind();

                }
                else
                {
                    if (comp == "1")
                        ((Button)(fvCliente.FindControl("InsertCancelButton"))).Text = "Cancelar compra";
                    fvCliente.DefaultMode = FormViewMode.Insert;
                }
            }
        }

        protected void odsCliente_Selecting(object sender, ObjectDataSourceSelectingEventArgs e)
        {
            string login = Session["userlogin"].ToString();

            e.InputParameters["login"] = login;
        }

        protected void odsCliente_Inserted(object sender, ObjectDataSourceStatusEventArgs e)
        {
            string comp = Request.Params["comp"].ToString();
            if (comp == "1") // Viene de una compra. Generaremos la factura y pasaremos a facturado el pedido.
            {
                PedidoBL pedidobl = new PedidoBL();
                if (pedidobl.FacturarPedido(Session["userlogin"].ToString()) != 0)
                {
                    Response.Redirect("Default.aspx");
                }
                else
                {
                    pnlMessage.Visible = true;
                    lblMessage.Text = "Error al facturar el pedido";
                }
            }
            else 
            {
                if (Convert.ToInt32(e.ReturnValue) != 0)
                    Response.Redirect("Default.aspx");
                else
                {
                    pnlMessage.Visible = true;
                    lblMessage.Text = "Error al insertar los datos";
                }
            }
        }

        protected void odsCliente_Updated(object sender, ObjectDataSourceStatusEventArgs e)
        {
            if (Convert.ToInt32(e.ReturnValue) != 0)
                Response.Redirect("Default.aspx");
            else
            {
                pnlMessage.Visible = true;
                lblMessage.Text = "Error al modificar los datos";
            }
        }

        protected void UpdateCancelButton_Click(object sender, EventArgs e)
        {
            Response.Redirect("Default.aspx");
        }

        protected void InsertCancelButton_Click(object sender, EventArgs e)
        {
            Response.Redirect("Default.aspx");
        }

        protected void btnVerFacturas_Click(object sender, EventArgs e)
        {
            string login = Session["userlogin"].ToString();
            Response.Redirect("Facturas.aspx?login=" + login);
        }

        protected void btnCambiarPassword_Click(object sender, EventArgs e)
        {
            Response.Redirect("Account/ChangePassword.aspx");
        }

        protected void btnCopiarDir_Click(object sender, EventArgs e)
        {
            ((DropDownList)(fvCliente.FindControl("ddlTipoViaEnv"))).SelectedValue = ((DropDownList)(fvCliente.FindControl("ddlTipoVia"))).SelectedValue;
            ((TextBox)(fvCliente.FindControl("direccion_envTextBox"))).Text = ((TextBox)(fvCliente.FindControl("direccionTextBox"))).Text;
            ((TextBox)(fvCliente.FindControl("cp_envTextBox"))).Text = ((TextBox)(fvCliente.FindControl("cpTextBox"))).Text;
            ((TextBox)(fvCliente.FindControl("poblacion_envTextBox"))).Text = ((TextBox)(fvCliente.FindControl("poblacionTextBox"))).Text;
            ((TextBox)(fvCliente.FindControl("pais_envTextBox"))).Text = ((TextBox)(fvCliente.FindControl("paisTextBox"))).Text;
        }

        protected void odsCliente_Deleting(object sender, ObjectDataSourceMethodEventArgs e)
        {
            string login = Session["userlogin"].ToString();

            e.InputParameters["login"] = login;
        }

        protected void odsCliente_Deleted(object sender, ObjectDataSourceStatusEventArgs e)
        {
            if (Convert.ToInt32(e.ReturnValue) != 0)
                Response.Redirect("Default.aspx");
            else
            {
                pnlMessage.Visible = true;
                lblMessage.Text = "Error al eliminar la cuenta";
            }
        }

        protected void odsCliente_Updating(object sender, ObjectDataSourceMethodEventArgs e)
        {
            e.InputParameters["login"] = Session["userlogin"].ToString();
        }

        protected void odsCliente_Inserting(object sender, ObjectDataSourceMethodEventArgs e)
        {
            e.InputParameters["login"] = Session["userlogin"].ToString();
        }
    }
}